--- getpatchname copy.c
+++ (clipboard)
@@ -1,4 +1,3 @@
-
 /* getpatchname - Returns the filename of the current patch 
  * 
  * Copyright (C) 2006 Jamie Bullock 
@@ -27,28 +26,38 @@
   t_object  x_obj;
   t_symbol *patch_name;
   t_outlet *outlet;
+  t_canvas *x_canvas;
+  int x_level;
 } t_getpatchname;
 
 void getpatchname_bang(t_getpatchname *x)
 {
 /* At some point we need to be to get the new patch name if it changes, couldn't make this work though */
-    outlet_symbol(x->outlet, x->patch_name);
+    int i = x->x_level;
+    t_canvas* last = x->x_canvas;
+    
+    while (i>0) {
+        i--;
+        if (last->gl_owner) last = last->gl_owner;
+    }
+    
+    outlet_symbol(x->outlet, last->gl_name);
 }
 
-void *getpatchname_new(void)
+void *getpatchname_new(t_floatarg level)
 {
   t_getpatchname *x = (t_getpatchname *)pd_new(getpatchname_class);
   x->patch_name = canvas_getcurrent()->gl_name;
+  x->x_canvas = canvas_getcurrent();
   x->outlet = outlet_new(&x->x_obj, &s_symbol);
+  x->x_level = level;
   return (void *)x;
 }
 
 void getpatchname_setup(void) {
   getpatchname_class = class_new(gensym("getpatchname"),
         (t_newmethod)getpatchname_new,
-        0, sizeof(t_getpatchname),
-        CLASS_DEFAULT, 0);
+        0, sizeof(t_getpatchname), 0,
+        A_DEFFLOAT, 0);
   class_addbang(getpatchname_class, getpatchname_bang);
 }
-
-
